%global dlrn_nvr validations-libs-1.6.0-2.20220526005227.eb5c38e
%global dlrn 1
%define upstream_version 1.6.0
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver 3
%else
%global pyver 2
%endif

%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility

%{!?upstream_version: %global upstream_version %{version}}
%global upstream_name validations-libs
%global sum A collection of python libraries for the Validation Framework

Name:           python-%{upstream_name}
Summary:        %{sum}
Version: 1.6.0
Release: 2.20220526005227.eb5c38e%{?dist}
License:        ASL 2.0
URL:            https://opendev.org/openstack/validations-libs
Source0: validations-libs-1.6.0-2.20220526005227.eb5c38e.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=eb5c38ee62e8bf3e13a8d10e1dd48ba5320e53b2
Patch0001: 0001-16.2-Only-Checking-inventory-file-presence-and-forma.patch

BuildArch:      noarch

%description
A collection of python libraries for the Validation Framework

%package -n     python%{pyver}-%{upstream_name}
Summary:        %{sum}
%{?python_provide:%python_provide python%{pyver}-%{upstream_name}}

BuildRequires:  git
BuildRequires:  openstack-macros
BuildRequires:  python%{pyver}-setuptools
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-pbr >= 3.1.1
BuildRequires:  python%{pyver}-testrepository
BuildRequires:  python%{pyver}-testscenarios
BuildRequires:  python%{pyver}-testtools
BuildRequires:  python%{pyver}-ansible-runner >= 1.2.0
%if %{pyver} == 2
BuildRequires:  python2-mock
BuildRequires:  python-pathlib2
BuildRequires:  python-configparser
%endif
BuildRequires:  python%{pyver}-cliff >= 2.16.0
BuildRequires:  python%{pyver}-oslotest >= 3.2.0

Requires:       python%{pyver}-pbr >= 3.1.1
Requires:       python%{pyver}-six >= 1.11.0
Requires:       python%{pyver}-ansible-runner >= 1.2.0
%if %{pyver} == 2
Requires:       PyYAML
Requires:       python-pathlib2
Requires:       python-configparser
%else
Requires:       python%{pyver}-PyYAML
%endif
Requires:       python%{pyver}-cliff >= 2.16.0

%description -n python%{pyver}-%{upstream_name}
A collection of python libraries for the Validation Framework

%prep
%autosetup -n %{upstream_name}-%{upstream_version} -S git

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%if %{pyver} == 2
find validations_libs -name \*.py -exec sed -i "1i\# -*- coding: utf-8 -*-" {} +
%endif

%build
%{pyver_build}

%install
%{pyver_install}

# Cleanup once https://review.opendev.org/#/c/755311/ is in tag release
if [ ! -d "%{buildroot}%{_datadir}/ansible" ]; then
mkdir -p %{buildroot}%{_datadir}/ansible
fi

# TODO remove this when https://review.opendev.org/c/openstack/validations-libs/+/792460 merged
if [ ! -d "%{buildroot}%{_sysconfdir}" ]; then
mkdir -p %{buildroot}%{_sysconfdir}
fi

if [ -f "%{buildroot}/usr/etc/validation.cfg" ]; then
mv %{buildroot}/usr/etc/validation.cfg %{buildroot}%{_sysconfdir}/validation.cfg
fi

if [ ! -f "%{buildroot}%{_sysconfdir}/validation.cfg" ]; then
cat <<EOF >%{buildroot}%{_sysconfdir}/validation.cfg
[default]
ansible_base_dir = /usr/share/ansible/
EOF
fi

# TODO(jpodivin) until callbacks are moved to validations-libs
# https://review.opendev.org/c/openstack/validations-libs/+/820551
if [ ! -d "%{buildroot}%{_datadir}/ansible/callback_plugins" ]; then
mkdir -p %{buildroot}%{_datadir}/ansible/callback_plugins
fi

%check

# Workaround py27 tests due to:
# https://bugs.launchpad.net/tripleo/+bug/1956751
%if %{pyver} == 2
PYTHON=%{pyver_bin} %{pyver_bin} setup.py test ||:
%else
PYTHON=%{pyver_bin} %{pyver_bin} setup.py test
%endif

%files -n python%{pyver}-%{upstream_name}
%license LICENSE
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/validation.cfg
%if 0%{?dlrn} > 0
%{_bindir}/validation
%endif
%doc README* AUTHORS ChangeLog
%{pyver_sitelib}/validations_libs
%{pyver_sitelib}/validations_libs-*.egg-info
%exclude %{pyver_sitelib}/validations_libs/test*
%{_datadir}/ansible/callback_plugins/

%changelog
* Wed May 25 2022 OSP Prod Chain <dev-null@redhat.com> 1.6.0-2.20220526005227.eb5c38e
- Update patches

* Thu May 19 2022 OSP Prod Chain <dev-null@redhat.com> 1.6.0-2.20220520014918.eb5c38e
- Update patches
- For stable/train compatibility ansible-runner needs to move to 1.4.0
- Move Cliff requirements to 2.16.0

* Fri May 06 2022 OSP Prod Chain <dev-null@redhat.com> 1.5.0-2.20220507005309.17e6895
- Update patches

* Thu Apr 07 2022 OSP Prod Chain <dev-null@redhat.com> 1.5.0-2.20220407135644.17e6895
- [16.2 Only] Checking inventory file presence and format (rhbz#2050765)

* Fri Jan 14 2022 OSP Prod Chain <dev-null@redhat.com> 1.5.0-2.20220115004852.17e6895
- Update patches

* Wed Jan 12 2022 OSP Prod Chain <dev-null@redhat.com> 1.5.0-2.20220112143537.17e6895
- Update patches
- Add backward compatibility for python pathlib module
- Convert fstrings to .format to facilitate porting
- Mocking 'open' to improve test isolation
- Disable spinner when running validation in non quiet mode
- Add the community validation paths
- Refactor set_argument_parser to fix shell regression
- Enforce existing roles and playbooks checks
- Add new CLI sub command to create community validations
- Use py3 as the default runtime for tox
- Default value of the constructor parameter
- Expose skip list mechanism via the CLI
- Add validation config file mechanism
- Setting language for the python3.6 tox environment
- Validations show group filtering
- Triggering the 'tripleo-ci-centos-8-undercloud-containers'
- Unit test refactor
- Add CLI auto generated documentation using Cliff
- Add Products metadata key management
- Add Categories metadata key management
- Add missing font for PDF generation
- Build containers in gate  - to match check
- Remove convert_data function
- add spinner to highlight progress
- improve vagrant functionality
- Test cross contamination prevention
- reqcheck job is now voting
- fix var name in logging statement
- Fix history list sub command when not using the default log dir
- Simplification of the log path handling by the ValidationLog class
- Handle backward compatibility for Cliff 2.16.0 (stable/train)
- Coverage change job
- Remove content-provider to decrease CI time
- Fix a regression in the ShowGroup sub-command
- Fix VALIDATIONS_LOG_BASEDIR constant when $HOME is undefined
- Correct the tox option for skipping sdist generation
- get_formatted_data optimization
- Literal substituted with DEFAULT_VALIDATIONS_BASEDIR
- Module docstring for validation_libs.constants
- Filling license info for Ansible and Pyflakes
- New optional param for log path
- Fixing the recursive path handling.
- Constants path formatting unification
- Improved log path handling
- Override cliff command parser to handle argparser conflict_handler
- Expansion of logging for the list action
- Paths no longer contain double '/'
- Expansion of logging for the show action.

* Fri Jan 07 2022 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20220108005000.04e84c8
- Update patches

* Tue Oct 12 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20211012144919.04e84c8
- Expose skip list mechanism via the CLI (rhbz#2013255)

* Fri Jun 25 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210625194809.04e84c8
- Update patches

* Mon Jun 07 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210607091343.04e84c8
- Update patches
- Update Validations Framework IRC channels
- Deprecated assertEquals replaced
- Cover now  prints line numbers

* Thu Jun 03 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210604015828.eda8127
- Update patches
- Remove VALIDATION_GROUPS constant
- Refactoring of the cli lister module
- Refactoring of the cli run module
- Refactoring of the cli history module
- Refactoring of the cli show module
- Refactoring of the cli app module
- Reqcheck job for upstream validations-libs

* Tue Jun 01 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210602020721.337288f
- Update patches
- Refactoring of the cli parseractions module

* Sat May 29 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210530014824.0f00fd7
- Update patches
- Use validation_component for Standalone CI jobs

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210527220217.b14fb37
- Update patches

* Sun May 23 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210523162210.b14fb37
- Update patches

* Sun May 23 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210523150045.b14fb37
- Update patches
- Bumping the ansible-runner version to 1.4.4
- Removing ansible-autodoc
- Fix Python 2.7 compatibility for test_ansible.py
- Make Python Interpreter option for Ansible Validation Run

* Thu May 20 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210520074709.51564ac
- Update patches
- Disable quiet mode run when using an Ansible Custom Callback

* Tue May 18 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210519014822.036ead6
- Update patches
- Elevate the verbosity level when running validation(s)
- Move fetch_validations role from validations-libs-functional to post playbook
- Bump pre-commit repositories
- group info test mocks and asserts
- Expanded and increased strictness of the ansible.py tests

* Tue May 11 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210512004812.5815fb3
- Update patches
- setup.cfg: Replace dashes with underscores

* Fri May 07 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210508004823.bfd8e33
- Update patches
- Retrieve n latest validation results

* Thu May 06 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210507004851.efca065
- Update patches
- Add support for JUnitXML output (optional)

* Thu Apr 29 2021 OSP Prod Chain <dev-null@redhat.com> 1.1.1-2.20210430004816.36c9b8c
- Update patches
- Version bumps for rhel9 transition

* Wed Apr 28 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.5-2.20210428174630.2c799eb
- Update patches
- CLI colors refactored
- Raise exception if result is empty

* Fri Apr 23 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.5-2.20210424005649.132d280
- Update patches
- Invalid char 'xe2' replaced with double dash
- PDF docs are now available
- Create dedicated CLI for the Validation Framework

* Tue Apr 20 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Exceptions now indicate cause where applicable

* Mon Apr 19 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Expose ansible ssh_user variable to the run action
- Add vars to tripleo-ci-centos-8-standalone-validation-libs job

* Wed Apr 14 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Tue Apr 13 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add basic standalone job w/ validate-services true
- Zuul runs tests in py36 only

* Sat Mar 27 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Fixes string formatting of the error msg log

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Expose callback_whitelist option to Run action

* Wed Mar 17 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Moving doc structure closer to that in validations-commons.

* Mon Mar 15 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Fix the syntax for groups in documentation.

* Fri Mar 12 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Default to current user dir for log creation and management

* Tue Mar 09 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Remove the condition to check the groups.

* Thu Mar 04 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Refactor the groups property in Validation class.

* Wed Mar 03 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Style adjustment of a constant.

* Thu Feb 25 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Return absolute path for inventory
- Modifies README.rst to reference podman.
- Docker image refinement and preparation for future development.
- Improved Dockefile and simplified use instructions.

* Wed Feb 24 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Removed unnecessary second check.

* Fri Feb 19 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add skip list option in order to provide a black list for validation
- show command now properly uses list of validations

* Wed Feb 17 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- One of the two nested calls of os.path.join was redundant.

* Wed Feb 03 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add new test for the parse_all_validations_on_disk
- Secondary loop removed. params_only dict now uses update method.
- OrderedDict can be constructed directly from dict instance

* Fri Jan 29 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add an error message when groups is not found in the playbook

* Fri Jan 22 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Local vars were redefining builtins

* Mon Jan 18 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Allow to provide different stdout callback to the libs

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Dockerfile for installing Validation Framework in a CentOS container

* Mon Jan 04 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Mon Jan 04 2021 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Fix typo in validations_libs/ansible.py

* Mon Dec 28 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Mon Dec 28 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Move ansible-runner version to 1.4.0
- Handle dynamically the ansible artifacts dir path
- Make the measuring code coverage test working
- The lower constraint file has been removed
- Bump pre-commit-hooks to v3.3.0

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Tue Dec 01 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Update TOX_CONSTRAINTS_FILE

* Thu Nov 26 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Handle unreachable case in the log statistics

* Wed Nov 25 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add Docstrings to validations_libs/ansible.py file
- Add Docstrings to validations_libs/validations_logs.py file
- Add Docstrings to validations_libs/validation_action.py file

* Fri Nov 20 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add Docstrings to validations_libs/group.py file

* Fri Nov 13 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Enforce the way we encapsulate a Validation

* Thu Nov 12 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add docstrings to utils.py
- Remove output format test in utils.get_validations_parameters

* Thu Nov 05 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Add better conversion of string parameters into a list

* Wed Nov 04 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Don't rely on parameter file extension for downloading

* Wed Oct 28 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Ensure we're using proper types for validation_name and _id
- add Vagrantfile for Validation Framework dev work

* Mon Oct 26 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Fix parameters management
- [Validator Run] Detect unknown validations from the command-line

* Wed Oct 21 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches
- Remove CI roles from validations-libs
- Add parameters values to the validation show command
- Fix show validation stats with correct number

* Mon Oct 12 2020 OSP Prod Chain <dev-null@redhat.com> 1.0.4-0.1
- Update patches

* Fri Oct 09 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add ansible dependency

* Tue Oct 06 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Install CI roles into ansible roles dir

* Fri Sep 18 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add the documentation build back in the CI
- Remove install unnecessary packages

* Mon Sep 14 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix lower-constraints errors
- Update validation path with the share/ansible one

* Fri Sep 04 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Allow to set python interper for ansible execution

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add lower ansible-runner version as requirements for train

* Wed Jul 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add a way to override the default validation log path

* Mon Jul 27 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Jul 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Switch legacy Zuul jobs to native Zuul v3 jobs

* Wed Jul 22 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Update openstackdocstheme.

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Show history by play and add get status action

* Mon Jul 06 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Change zuul config for functional CI execution

* Wed Jul 01 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Remove playbook param from run_validation

* Mon Jun 22 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Switch to newer openstackdocstheme and reno versions

* Wed Jun 17 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add base_dir param to override the constants value easily

* Mon Jun 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Filter get_all_log_file by extension

* Thu Jun 11 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Catch value error when extract log info from log name

* Mon May 25 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Handle multiple validation logs results

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add API Documentation structure

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Avoid None value when missing data in ansible log

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix title.
- Raise exception if no validation is found
- Add asynchronous option to validation libs

* Thu May 07 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Update the minversion parameter.

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Move unit tests execution to stestr

* Mon Apr 27 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Bump default tox env from py37 to py38
- Add py38 package metadata

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add Python3 victoria unit tests

* Sun Apr 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Format output in json or yaml for validations show param

* Sat Apr 18 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Use validation_path attribut instead of variables

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Declare playbooks for groups execution
- Expose limit hosts option to the validation run actions

* Wed Apr 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

